//
// File: PanelCadres.cc
// Created by: Éric Laly <elaly@free.fr>
// Created on: Thu Oct 19 10:09:09 2006
//

#include "PanelCadres.h"


PanelCadres::PanelCadres(int nombrecadres,wxWindow* parent,int id):wxPanel(parent,id)
{
    mon_parent=parent;
    
    //on crée le sizer qui contient les contrôles gérant le nombre de cadres
    NombreCadres=nombrecadres;
    label_nombre_cadres = new wxStaticText(this, -1, wxT("Nombre de cadres: "));
    wxString temp(wxT(""));temp<<NombreCadres;
    spin_ctrl_nombre_cadres = new wxSpinCtrl(this, -1, temp, wxDefaultPosition, wxDefaultSize, wxTE_READONLY, 0, 10);
    wxBoxSizer* sizer_nombre_cadres = new wxBoxSizer(wxHORIZONTAL);
    sizer_nombre_cadres->Add(label_nombre_cadres, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    sizer_nombre_cadres->Add(spin_ctrl_nombre_cadres, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 2);
    
    // on crée une ligne de séparation (permet aussi de donner une largeur minimum...)
    static_line_sep = new wxStaticLine(this, -1);
    static_line_sep->SetMinSize(wxSize(700, 2));
 
    // on crée un panel scrollable qui va contenir les panels de paramétrage des cadres
    sw_cadres=new wxScrolledWindow(this,-1);
    sw_cadres->SetScrollRate(10,10);
    sizer_cadres = new wxBoxSizer(wxVERTICAL);
    sw_cadres->SetSizer(sizer_cadres);
    //on crée le nombre de PanelSaisieParametresCadre demandés et on les ajoute au sizer
    panels_cadre.resize(nombrecadres);
    for (int i=0; i<nombrecadres;i++)
    {    
        wxString temp(wxT("Cadre "));temp<<i+1;
        panels_cadre[i]=new PanelSaisieParametresCadre(sw_cadres,-1,temp,wxColour(0, 0, 0));
        sizer_cadres->Add(panels_cadre[i], 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 2);
    }
    sizer_cadres->Fit(sw_cadres); //on met le sizer à la taille du panel scrollable pour qu'il contienne le nombre de cadre par défaut
    // on ajoute les élements que l'on vient de créer au sizer principal
    sizer_parametres_cadres = new wxBoxSizer(wxVERTICAL);
    sizer_parametres_cadres->Add(sizer_nombre_cadres, 0, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_HORIZONTAL, 2);
    sizer_parametres_cadres->Add(static_line_sep, 0, wxEXPAND, 0);
    sizer_parametres_cadres->Add(sw_cadres, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 2);
    
    SetSizer(sizer_parametres_cadres);// on affecte le sizer principal au panel principal
    
    sizer_parametres_cadres->Fit(this);// on met le sizer à la taille du panel
    // on connecte les évènements
 	Connect(spin_ctrl_nombre_cadres->GetId( ), wxEVT_COMMAND_SPINCTRL_UPDATED,(wxObjectEventFunction) &PanelCadres::AjouteOuEnleveCadre);
}

PanelCadres::~PanelCadres()
{
}

void PanelCadres::AjouteOuEnleveCadre(wxCommandEvent& event)
{
    if (NombreCadres<spin_ctrl_nombre_cadres->GetValue())
    {   
        NombreCadres=spin_ctrl_nombre_cadres->GetValue();
        panels_cadre.resize(NombreCadres);
        wxString temp(wxT("Cadre "));temp<<NombreCadres;
        panels_cadre[NombreCadres-1]=new PanelSaisieParametresCadre(sw_cadres,-1,temp,wxColour(0, 0, 0));
        sizer_cadres->Add(panels_cadre[NombreCadres-1], 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 2);
    } else {
        delete panels_cadre[NombreCadres-1];
        panels_cadre.resize(NombreCadres-1);
        NombreCadres=spin_ctrl_nombre_cadres->GetValue();
    } 
    sizer_parametres_cadres->Layout();// nécessaire 
}   

vector <double> PanelCadres::GetPourcentages()
{
    PourcentagesCadres.clear();
    for (unsigned int i=0;i<panels_cadre.size();i++) 
    {   
        PourcentagesCadres.push_back(panels_cadre[i]->GetPourcentage());
    }   
    return PourcentagesCadres;
} 

vector <wxColor> PanelCadres::GetCouleurs()
{
    CouleursCadres.clear();
    for (unsigned int i=0;i<panels_cadre.size();i++) CouleursCadres.push_back(panels_cadre[i]->GetCouleur());
    return CouleursCadres;
}

vector <bool> PanelCadres::GetCouleursAuto()
{
    CouleursCadresAuto.clear();
    for (unsigned int i=0;i<panels_cadre.size();i++) CouleursCadresAuto.push_back(panels_cadre[i]->GetCouleurAuto());
    return CouleursCadresAuto;
}
